package cn.com.infosec.crypto.params;

import cn.com.infosec.crypto.CipherParameters;
import java.math.BigInteger;

public class DSAParameters implements CipherParameters {
   private BigInteger g;
   private BigInteger q;
   private BigInteger p;
   private DSAValidationParameters validation;

   public DSAParameters(BigInteger p, BigInteger q, BigInteger g) {
      this.g = g;
      this.p = p;
      this.q = q;
   }

   public DSAParameters(BigInteger p, BigInteger q, BigInteger g, DSAValidationParameters params) {
      this.g = g;
      this.p = p;
      this.q = q;
      this.validation = params;
   }

   public BigInteger getP() {
      return this.p;
   }

   public BigInteger getQ() {
      return this.q;
   }

   public BigInteger getG() {
      return this.g;
   }

   public DSAValidationParameters getValidationParameters() {
      return this.validation;
   }

   public boolean equals(Object obj) {
      if (!(obj instanceof DSAParameters)) {
         return false;
      } else {
         DSAParameters obj1;
         return (obj1 = (DSAParameters)obj).getP().equals(this.p) && obj1.getQ().equals(this.q) && obj1.getG().equals(this.g);
      }
   }

   public int hashCode() {
      return this.getP().hashCode() ^ this.getQ().hashCode() ^ this.getG().hashCode();
   }
}
